"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from datetime import datetime
import dateutil.parser
from orq_ai_sdk.types import BaseModel
from orq_ai_sdk.utils import FieldMetadata, PathParamMetadata, RequestMetadata
import pydantic
from typing import Literal, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class FileUpdateRequestBodyTypedDict(TypedDict):
    file_name: str


class FileUpdateRequestBody(BaseModel):
    file_name: str


class FileUpdateRequestTypedDict(TypedDict):
    file_id: str
    r"""The ID of the file"""
    request_body: NotRequired[FileUpdateRequestBodyTypedDict]


class FileUpdateRequest(BaseModel):
    file_id: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""The ID of the file"""

    request_body: Annotated[
        Optional[FileUpdateRequestBody],
        FieldMetadata(request=RequestMetadata(media_type="application/json")),
    ] = None


FileUpdatePurpose = Literal["retrieval", "knowledge_datasource"]
r"""The intended purpose of the uploaded file."""


class FileUpdateResponseBodyTypedDict(TypedDict):
    r"""File updated successfully"""

    id: str
    object_name: str
    r"""path to the file in the storage"""
    purpose: FileUpdatePurpose
    r"""The intended purpose of the uploaded file."""
    bytes_: float
    file_name: str
    workspace_id: str
    r"""The id of the resource"""
    created: NotRequired[datetime]
    r"""The date and time the resource was created"""


class FileUpdateResponseBody(BaseModel):
    r"""File updated successfully"""

    id: Annotated[str, pydantic.Field(alias="_id")]

    object_name: str
    r"""path to the file in the storage"""

    purpose: FileUpdatePurpose
    r"""The intended purpose of the uploaded file."""

    bytes_: Annotated[float, pydantic.Field(alias="bytes")]

    file_name: str

    workspace_id: str
    r"""The id of the resource"""

    created: Optional[datetime] = dateutil.parser.isoparse("2025-01-02T13:55:01.176Z")
    r"""The date and time the resource was created"""
